org.freeplane.plugin.script.proxy

## Interface Proxy

-     public interface Proxy

  This interface alone defines the api for accessing the internal state of the Freeplane. All read-write methods and properties (with rare, documented exceptions in `Proxy.Controller` and `Proxy.Map`) support undo and rollback on exceptions.

  Every Proxy subinterface comes in two variants:

  - A read-only interface, like `Proxy.NodeRO`. This collects only the methods that don't change the underlying object (in case of `NodeRO` this would be `NodeModel`.
  - A read-write interface, like `Proxy.Node`. This inherits from the respective read-only interface all its methods and properties and adds write access to the underlying object.
  The main point of this distinction are formulas: Only the methods defined in the read-only interfaces are supported in Formulas!. Changing values in a Formula are against the Formula concept and lead to corruption of the caching mechanism for Formulas.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static interface` | `Proxy.Attributes` Node's attribute table: `node.attributes` - read-write.
    `static interface` | `Proxy.AttributesRO` Node's attribute table: `node.attributes` - read-only.
    `static interface` | `Proxy.Cloud` Here are four ways to enable a cloud on the current node and switch it off again: node.cloud.enabled = true node.cloud.enabled = false node.cloud.shape = 'ROUND_RECT' // either 'ARC', 'STAR', 'RECT' or 'ROUND_RECT' node.cloud.shape = null node.cloud.color = java.awt.Color.YELLOW node.cloud.color = null node.cloud.colorCode = '#00FF66' node.cloud.color = null
    `static interface` | `Proxy.Connector` Graphical connector between nodes:`node.connectorsIn` / `node.connectorsOut` - read-write.
    `static interface` | `Proxy.ConnectorRO` Graphical connector between nodes:`node.connectorsIn` / `node.connectorsOut` - read-only.
    `static interface` | `Proxy.Controller` Access to global state: in scripts, this is available as global variable `c` - read-write.
    `static interface` | `Proxy.ControllerRO` Access to global state: in scripts, this is available as global variable `c` - read-only.
    `static interface` | `Proxy.Edge` Edge to parent node: `node.style.edge` - read-write.
    `static interface` | `Proxy.EdgeRO` Edge to parent node: `node.style.edge` - read-only.
    `static interface` | `Proxy.ExternalObject` External object: `node.externalObject` - read-write.
    `static interface` | `Proxy.ExternalObjectRO` External object: `node.externalObject` - read-only.
    `static interface` | `Proxy.Font` Node's font: `node.style.font` - read-write.
    `static interface` | `Proxy.FontRO` Node's font: `node.style.font` - read-only.
    `static interface` | `Proxy.Icons` Node's icons: `node.icons` - read-write.
    `static interface` | `Proxy.IconsRO` Node's icons: `node.icons` - read-only.
    `static interface` | `Proxy.Link` Node's link: `node.link` - read-write.
    `static interface` | `Proxy.LinkRO` Node's link: `node.link` - read-only.
    `static interface` | `Proxy.Map` The map a node belongs to: `node.map` - read-write.
    `static interface` | `Proxy.MapRO` The map a node belongs to: `node.map` - read-only.
    `static interface` | `Proxy.Node` The currently selected node: `node` - read-write.
    `static interface` | `Proxy.NodeRO` The currently selected node: `node` - read-only.
    `static interface` | `Proxy.NodeStyle` Node's style: `node.style` - read-write.
    `static interface` | `Proxy.NodeStyleRO` Node's style: `node.style` - read-only.
    `static interface` | `Proxy.Properties`
    `static interface` | `Proxy.Reminder` Reminder: `node.reminder` - read-write.
    `static interface` | `Proxy.ReminderRO` Reminder: `node.reminder` - read-only.